<?php

namespace patest\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GiftVoucher.AddGiftVoucherToBasketRequest StructType
 * @subpackage Structs
 */
class GiftVoucher_AddGiftVoucherToBasketRequest extends AnyEntity
{
    /**
     * The GiftVoucherNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $GiftVoucherNumber;
    /**
     * The RedemptionValue
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $RedemptionValue;
    /**
     * Constructor method for GiftVoucher.AddGiftVoucherToBasketRequest
     * @uses GiftVoucher_AddGiftVoucherToBasketRequest::setGiftVoucherNumber()
     * @uses GiftVoucher_AddGiftVoucherToBasketRequest::setRedemptionValue()
     * @param string $giftVoucherNumber
     * @param string $redemptionValue
     */
    public function __construct($giftVoucherNumber = null, $redemptionValue = null)
    {
        $this
            ->setGiftVoucherNumber($giftVoucherNumber)
            ->setRedemptionValue($redemptionValue);
    }
    /**
     * Get GiftVoucherNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getGiftVoucherNumber()
    {
        return isset($this->GiftVoucherNumber) ? $this->GiftVoucherNumber : null;
    }
    /**
     * Set GiftVoucherNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $giftVoucherNumber
     * @return \patest\StructType\GiftVoucher_AddGiftVoucherToBasketRequest
     */
    public function setGiftVoucherNumber($giftVoucherNumber = null)
    {
        // validation for constraint: string
        if (!is_null($giftVoucherNumber) && !is_string($giftVoucherNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($giftVoucherNumber, true), gettype($giftVoucherNumber)), __LINE__);
        }
        if (is_null($giftVoucherNumber) || (is_array($giftVoucherNumber) && empty($giftVoucherNumber))) {
            unset($this->GiftVoucherNumber);
        } else {
            $this->GiftVoucherNumber = $giftVoucherNumber;
        }
        return $this;
    }
    /**
     * Get RedemptionValue value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRedemptionValue()
    {
        return isset($this->RedemptionValue) ? $this->RedemptionValue : null;
    }
    /**
     * Set RedemptionValue value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $redemptionValue
     * @return \patest\StructType\GiftVoucher_AddGiftVoucherToBasketRequest
     */
    public function setRedemptionValue($redemptionValue = null)
    {
        // validation for constraint: string
        if (!is_null($redemptionValue) && !is_string($redemptionValue)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($redemptionValue, true), gettype($redemptionValue)), __LINE__);
        }
        if (is_null($redemptionValue) || (is_array($redemptionValue) && empty($redemptionValue))) {
            unset($this->RedemptionValue);
        } else {
            $this->RedemptionValue = $redemptionValue;
        }
        return $this;
    }
}
